Description

In source:/trunk/app/models/mail_handler.rb@13413#L424, whether String#force_encoding is defined is used to make a decision

about Mail::RubyVer, which defines pick_encoding on everything but Ruby 1.8.

This is dangerous as it couples knowledge about Ruby 1.8 (String#force_encoding is not defined) with knowledge about the Mail

gem internals (Mail::RubyVer.pick_encoding is not defined on 1.8), there is no guarantee that this will always be the case though.

The attached patch checks whether Mail::RubyVer.pick_encoding is defined before using it instead of using the indirection through

whether String#force_encoding is defined or not.

Related issues:

Related to Redmine - Patch #15785: Support more character encodings in incomi... Closed

Associated revisions

Revision 13432 - 2014-10-08 16:59 - Toshi MARUYAMA

MailHandler: Don't use String#respond_to?(:force_encoding) (#18047)

Contributed by Felix Schäfer.

History

#1 - 2014-10-08 16:07 - Toshi MARUYAMA

- Related to Patch #15785: Support more character encodings in incoming emails added

#2 - 2014-10-08 16:13 - Toshi MARUYAMA

- Category set to Email receiving

- Target version set to 2.6.0

#3 - 2014-10-08 16:54 - Toshi MARUYAMA

- Subject changed from Don't use String#respond_to?(:force_encoding) to differentiate between Ruby 1.8 and Ruby 1.9 to MailHandler: Don't use

String#respond_to?(:force_encoding) to differentiate between Ruby 1.8 and Ruby 1.9

#4 - 2014-10-09 05:27 - Toshi MARUYAMA

- Status changed from New to Closed

Committed in trunk r13432, thanks.

Rails 4 dropped Ruby 1.8 support.

So, Rails 4 branch r13255 removed this check.

#5 - 2014-10-09 09:12 - Felix Schäfer

Great, thanks!
